%define _enable_debug_packages %{nil}
%define debug_package %{nil}

# The revision number should match the first three digits
# shown in TextMaker's Help > About
%define revision 759

%define oversion 16

Summary:	SoftMaker FreeOffice
Name:		softmaker-freeoffice
Version:	2016
Release:	%{revision}.2
License:	Freeware
Group:		Office
Url:		http://www.freeoffice.com
# Not allowed to re-distribute outside of ROSA products and repositories
Source0:	%{name}-%{revision}.tgz
Source1:	softmaker-freeoffice-license.txt
# Hunspell dictionaries
Source10:	http://www.softmaker.net/down/hunspell/softmaker-hunspell-russian.sox
Source11:	softmaker-hunspell-byelorussian-official.sox
Source12:	softmaker-hunspell-french-recommended.sox
Source13:	softmaker-hunspell-italian.sox
Source14:	softmaker-hunspell-polish.sox
Source15:	softmaker-hunspell-spanish-spain.sox
Source16:	softmaker-hunspell-ukrainian.sox
# Adjust desktop files for our needs
Patch0:		softmaker-freeoffice-2016-desktop.patch
BuildRequires:	imagemagick
ExclusiveArch:	%{ix86}

%description
SoftMaker FreeOffice is a complete office suite.

It is reliable, lightning-fast, and Microsoft Office-compatible and comes
with a word processor, spreadsheet, and presentation graphics software.

Important! This edition of SoftMaker FreeOffice doesn't require a product key.
It's not allowed to be distributed outside of ROSA repositories and products.

%files
%doc softmaker-freeoffice-license.txt
%{_bindir}/planmaker
%{_bindir}/presentations
%{_bindir}/textmaker
%{_datadir}/applications/planmaker.desktop
%{_datadir}/applications/presentations.desktop
%{_datadir}/applications/textmaker.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_iconsdir}/hicolor/*/apps/planmaker.png
%{_iconsdir}/hicolor/*/apps/presentations.png
%{_iconsdir}/hicolor/*/apps/textmaker.png
%{_iconsdir}/hicolor/*/mimetypes/application-x-pmd.png
%{_iconsdir}/hicolor/*/mimetypes/application-x-prd.png
%{_iconsdir}/hicolor/*/mimetypes/application-x-tmd.png
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*

%post
if [ `rpm -q softmaker-freeoffice-install | wc -w` == 1 ]
then
    rpm -e softmaker-freeoffice-install
fi

#----------------------------------------------------------------------------

%prep
%setup -q -c
cp %{SOURCE1} .

mkdir smfree
tar xf freeoffice.tgz -C smfree
rm -f freeoffice.tgz
%patch0 -p1

# Because x86_64 package is a mix of 32 bit main binaries and smserver64
# we should rather ship pure 32 bit package only
rm -f smfree/smserver64

# mv master/ofl%{oversion}files/smfree/mime .
# Use standard icons from icon themes for mimetypes
sed -i s,application-x-pmd,x-office-spreadsheet,g smfree/mime/%{name}%{oversion}.xml
sed -i s,application-x-prd,x-office-presentation,g smfree/mime/%{name}%{oversion}.xml
sed -i s,application-x-tmd,x-office-document,g smfree/mime/%{name}%{oversion}.xml

# Hunspell dictionaries
mkdir smfree/hunspell
unzip %{SOURCE10} -d smfree/hunspell/ru_RU/
unzip %{SOURCE11} -d smfree/hunspell/be_BY_Official/
unzip %{SOURCE12} -d smfree/hunspell/fr_FR_Recommended/
unzip %{SOURCE13} -d smfree/hunspell/it_IT/
unzip %{SOURCE14} -d smfree/hunspell/pl_PL/
unzip %{SOURCE15} -d smfree/hunspell/es_ES/
unzip %{SOURCE16} -d smfree/hunspell/uk_UA/

%build

%install
# Copy main files
mkdir -p %{buildroot}%{_libdir}/%{name}
cp -r smfree/* %{buildroot}%{_libdir}/%{name}/
#cp -r shared_free/* %{buildroot}%{_libdir}/%{name}/
chmod 755 %{buildroot}%{_libdir}/%{name}/planmaker
chmod 755 %{buildroot}%{_libdir}/%{name}/presentations
chmod 755 %{buildroot}%{_libdir}/%{name}/textmaker

# Create symlinks to run applications
mkdir -p %{buildroot}%{_bindir}

# Install desktop files
mkdir -p %{buildroot}%{_datadir}/applications/
install -m 644 smfree/mime/pml%{oversion}.dsk %{buildroot}%{_datadir}/applications/planmaker.desktop
install -m 644 smfree/mime/prl%{oversion}.dsk %{buildroot}%{_datadir}/applications/presentations.desktop
install -m 644 smfree/mime/tml%{oversion}.dsk %{buildroot}%{_datadir}/applications/textmaker.desktop

# Install menu icons
for N in 16 32 48 64 128 256 512;
do
install -D -m 0644 smfree/icons/pml_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/apps/planmaker.png
install -D -m 0644 smfree/icons/prl_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/apps/presentations.png
install -D -m 0644 smfree/icons/tml_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/apps/textmaker.png
done

# Install mime icons (not used for now)
for N in 16 32 48 64 128;
do
install -D -m 0644 smfree/icons/pmd_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/mimetypes/application-x-pmd.png
install -D -m 0644 smfree/icons/prd_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/mimetypes/application-x-prd.png
install -D -m 0644 smfree/icons/tmd_${N}.png %{buildroot}%{_iconsdir}/hicolor/${N}x${N}/mimetypes/application-x-tmd.png
done

# Install mimetypes
mkdir -p %{buildroot}%{_datadir}/mime/packages/
install -m 644 smfree/mime/%{name}%{oversion}.xml %{buildroot}%{_datadir}/mime/packages/%{name}.xml

# Create wrappers to run applications
mkdir -p %{buildroot}%{_bindir}

cat > %{buildroot}%{_bindir}/planmaker << EOF
#!/bin/sh
# A script to run PlanMaker
if test ! -e \$HOME/.softmaker/hunspell
then
    mkdir -p \$HOME/.softmaker/hunspell/
    cp -r %{_libdir}/%{name}/hunspell/* \$HOME/.softmaker/hunspell/
fi
%{_libdir}/%{name}/planmaker "\$@"
EOF
chmod +x %{buildroot}%{_bindir}/planmaker

cat > %{buildroot}%{_bindir}/presentations << EOF
#!/bin/sh
# A script to run Presentations
if test ! -e \$HOME/.softmaker/hunspell
then
    mkdir -p \$HOME/.softmaker/hunspell/
    cp -r %{_libdir}/%{name}/hunspell/* \$HOME/.softmaker/hunspell/
fi
ext="\${@##*.}"
shopt -s nocasematch
case "\$ext" in
    "prs" ) %{_libdir}/%{name}/presentations -S\""\$@"\";;
    "pps" ) %{_libdir}/%{name}/presentations -S\""\$@"\";;
    "ppsx" ) %{_libdir}/%{name}/presentations -S\""\$@"\";;
    * ) %{_libdir}/%{name}/presentations "\$@";;
esac
EOF
chmod +x %{buildroot}%{_bindir}/presentations

cat > %{buildroot}%{_bindir}/textmaker << EOF
#!/bin/sh
# A script to run TextMaker
if test ! -e \$HOME/.softmaker/hunspell
then
    mkdir -p \$HOME/.softmaker/hunspell/
    cp -r %{_libdir}/%{name}/hunspell/* \$HOME/.softmaker/hunspell/
fi
LD_LIBRARY_PATH=\$LD_LIBRARY_PATH:%{_libdir}/%{name}/dpf %{_libdir}/%{name}/textmaker "\$@"
EOF
chmod +x %{buildroot}%{_bindir}/textmaker


%changelog

* Tue Jul 26 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 2016-759.2
- (7dc48f5) Remove softmaker-freeoffice-install package if it's installed (don't use Obsoletes because we don't want to force such replacement)


